#!/bin/sh
#
# Start or stop dents
#
# Michel Onstein <promera@debian.org>
#

test -x /usr/sbin/dents || exit 0

case "$1" in
	start)
		echo -n "Starting domain name service: dents"
		start-stop-daemon --start --quiet --exec /usr/sbin/dents -- -p 1053
		echo "."
	;;

	stop)
		echo -n "Stopping domain name service: dents"
		start-stop-daemon --stop --quiet --pidfile /var/run/dents.pid --exec /usr/sbin/dents
		echo "."
	;;

	restart)
		$0 stop
		$0 start
	;;

	*) 
		echo "Usage: /etc/init.d/dents {start|stop|restart}" >&2
		exit 1
	;;
esac

exit 0

