/* This type is used on the parent side to record a child.  "domains"
 * serves also for reference-counting; when the list reaches length
 * zero, we tell the child to take the long walk off of the short pier. */

#ifndef MODMSGTGL_H
#define MODMSGTGL_H

#include <config.h>
#include <db.h>
#include <glib.h>
#include <common.h>

#ifndef WITH_PTHREAD
#error MUST_HAVE_PTHREAD
#endif /*WITH_PTHREAD */

#define RBUF_SIZE 255
#define INDEX_SIZE 64

typedef struct dproc_zone {
    char   *name;
    char  **args;
    int     restarts;
    int     options;
    char   *soa_mname;
    char   *soa_rname;
    u_int32_t soa_serial;
    u_int32_t soa_refresh;
    u_int32_t soa_retry;
    u_int32_t soa_expire;
    u_int32_t soa_minimum;
} dproc_zone;

typedef struct dproc {
    char   *name;
    pid_t   pid;
	int snum;
    gboolean is_dead;
    int     status;
    int     rfile;
    int     wfile;
    int     los;
    int     lof;
    char    rbuf[RBUF_SIZE];
    char   *index[INDEX_SIZE];
    GList  *domains;		/* dproc_zone */
    unsigned int refcount;
    GMutex *lock;
    struct dproc *prev;
    struct dproc *next;
} dproc;

#define DPROC_EXTENDEDQ 1
#define DPROC_NUMERIC 2

#endif /*MODMSGTGL_H */
