#include <string.h>		/* strcmp */
#include "stoi.h"

stoi_t  stoi_rrtypes[] =
{
    {1, "A"},
    {2, "NS"},
    {3, "MD"},
    {4, "MF"},
    {5, "CNAME"},
    {6, "SOA"},
    {7, "MB"},
    {8, "MG"},
    {9, "MR"},
    {10, "NULL"},
    {11, "WKS"},
    {12, "PTR"},
    {13, "HINFO"},
    {14, "MINFO"},
    {15, "MX"},
    {16, "TXT"},
    {17, "RP"},
    {18, "AFSDB"},
    {19, "X25"},
    {20, "ISDN"},
    {21, "RT"},
    {22, "NSAP"},
    {23, "NSAP_PTR"},
    {24, "SIG"},
    {25, "KEY"},
    {26, "PX"},
    {27, "GPOS"},
    {28, "AAAA"},
    {29, "LOC"},
    {30, "NXT"},
    {31, "EID"},
    {32, "NIMLOC"},
    {33, "SRV"},
    {34, "ATMA"},
    {35, "NAPTR"},
    {100, "UINFO"},
    {101, "UID"},
    {102, "GID"},
    {103, "UNSPEC"},
    {251, "IXFR"},
    {252, "AXFR"},
    {253, "MAILB"},
    {254, "MAILA"},
    {255, "ANY"},
    {0, 0}
};

stoi_t  stoi_ctypes[] =
{
    {1, "IN"},
    {2, "CS"},
    {3, "CH"},
    {4, "HS"},
    {255, "ANY"},
    {0, 0}
};

stoi_t  stoi_errtypes[] =
{
    {-2, "WAITFORMOREINFO"},
    {-1, "NOINFO"},
    {0, "NOERROR"},
    {1, "FORMERR"},
    {2, "SERVFAIL"},
    {3, "NXDOMAIN"},
    {4, "NOTIMP"},
    {5, "REFUSED"},
    {0, 0}
};

stoi_t  stoi_optypes[] =
{
    {0, "STANDARD"},
    {1, "INVERSE"},
    {2, "STATUS"},
    {0, 0}
};

stoi_t  stoi_sections[] =
{
    {0, "ANSWER"},
    {1, "NS"},
    {2, "ADDITIONAL"},
    {3, "CACHE"},
    {0, 0}
};

int
stoi(char *s, stoi_t tab[])
{
    stoi_t *cursor;

    for (cursor = tab; cursor->s; cursor++) {
	if (!(strcmp(cursor->s, s))) {
	    return (cursor->i);
	}
    }
    return (-1);
}

char   *
itos(int i, stoi_t tab[])
{
    stoi_t *cursor;

    for (cursor = tab; cursor->s; cursor++) {
	if (cursor->i == i) {
	    return (cursor->s);
	}
    }
    return (NULL);
}
