/* mod_template.c - XXCOMMENTXX

   Dents - a threaded modular dns-server.
   Copyright (C) 1999  Dents Team  (http://www.dents.org)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or (at
   your option) any later version. This program is distributed in the
   hope that it will be useful, but WITHOUT ANY WARRANTY; without even
   the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
   PURPOSE.  See the GNU General Public License for more details.  */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

/* Add system headers here */
#include <glib.h>

/*
 * mod_template.c
 *
 *  Template module. See comments for details
 */
#include "dns.h"

/* Basic info on the module, used later */
#define MODULE_NAME	mod_template

#define MODULE_VER_MAJOR 1
#define MODULE_VER_MINOR 0
#define MODULE_VER_MICRO 0

#include "module_syms.h"
#include "dns_module_syms.h"

/*
 * mod_template_answer
 *
 *  An answering function
 */
int
mod_template_answer (void)
{
  printf ("mod_telmate_answer: Called\n");

  return (0);
}

/*
 * Exported functions
 */

/*
 * module_dns_zone_add
 *
 *  Add's a zone
 */
MODULE_FUNC (int, dns_zone_add, (dnszonerec * zone))
{
  printf ("mod_template_dns_zone_add: Called\n");

  return (0);
}

/*
 * module_dns_zone_delete
 *
 *  Delete's a zone
 */
MODULE_FUNC (int, dns_zone_delete, (dnszonerec * zone))
{
  printf ("mod_template_dns_zone_delete: Called\n");

  return (DE_NOTIMP);
}

/*
 * module_dns_zone_load
 *
 *  Load's a zone (off of disk for instance)
 */
MODULE_FUNC (int, dns_zone_load, (dnszonerec * zone))
{
  return (0);
}

/*
 * module_dns_zone_reload
 *
 *  Reload's a zone
 */
MODULE_FUNC (int, dns_zone_reload, (dnszonerec * zone))
{
  return (DE_NOTIMP);
}

/*
 * module_init
 *
 *  All we do is just print a banner
 */
MODULE_FUNC (int, init, (void))
{
  DPRINTF (("mod_tmplate_init: version %s by Johannes Erdfelt\n", VERSION));
  return (0);
}

/*
 * module_destroy
 *
 *  Called when the module is unloaded. Always fter all zones have
 * stopped using it
 */
MODULE_FUNC (void, destroy, (void))
{
  DPRINTF (("mod_template_destroy: exiting\n"));
}

/*
 * Module compile support code
 */

/* Each answering function in order of desired execution. The list MUST */
/*  be NULL terminated */
MODULE_DNS_ANSWER = {
mod_template_answer, NULL};

/*
 * Exported symbols
 */
MODULE_SYMS (MODULE_SYMS_INIT	/* module_init() */
	     MODULE_SYMS_DESTROY	/* module_destroy() */
	     MODULE_SYMS_DNS	/* Mandatory DNS symbols */
	     /* module_dns_zone_add() */
	     /* module_dns_zone_delete() */
	     /* module_dns_answer() */
	     MODULE_SYMS_DNS_ZONE_RELOAD	/* module_dns_zone_reload() */
	     MODULE_SYMS_DNS_ZONE_LOAD	/* module_dns_zone_load() */
  )
