/* dns_comp.h - DNS compression routines.

   Dents - a threaded modular dns-server.
   Copyright (C) 1999  Dents Team  (http://www.dents.org)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or (at
   your option) any later version. This program is distributed in the
   hope that it will be useful, but WITHOUT ANY WARRANTY; without even
   the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
   PURPOSE.  See the GNU General Public License for more details.  */

#ifndef DNS_COMP_H
#define DNS_COMP_H

/* The maximum number of labels we keep track of for compression */
#define DNS_MAXCOMPRESSPTRS     64

/* The scratch structure used in the DNS routines */
typedef struct
{
  guint numcp;			/* Number of pointers currently used */
  guchar *compptrs[DNS_MAXCOMPRESSPTRS];
}
dnscompressrec;

/* dns_comp.c */
guchar *dns_compressname (guchar * cp, guchar * name, guchar * buf,
			  dnscompressrec * cmp);
guchar *dns_compressquery (packetrec * p, guchar * cp, guchar * dname,
			   dnsqueryrec * query, dnscompressrec * cmp);
guchar *dns_compressrr (packetrec * p, guchar * cp, guchar * dname,
			dnsbuildrrrec * rr, dnscompressrec * cmp);

#endif /* DNS_COMP_H */
