/* dns_module.h - XXCOMMENTXX

   Dents - a threaded modular dns-server.
   Copyright (C) 1999  Dents Team  (http://www.dents.org)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or (at
   your option) any later version. This program is distributed in the
   hope that it will be useful, but WITHOUT ANY WARRANTY; without even
   the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
   PURPOSE.  See the GNU General Public License for more details.  */
/*
 * dns_module.h
 *
 *  DNS specific module code
 */
#ifndef DNS_MODULE_H
#define DNS_MODULE_H

/* struct prototyping */
struct modulerec;
struct dnszonerec;

/* This is the struct that gets populated for each module. */
typedef struct dnsmodulerec
{
  llentry ll;			/* Linked list (blocklist) */

  struct modulerec *mod;	/* Pointer to module */

  /* Mandatory functions */
  int (*zone_add) (struct dnszonerec * zone);	/* Add a zone */
  int (*zone_delete) (struct dnszonerec * zone);	/* Delete a zone */
  int (*zone_load) (struct dnszonerec * zone);	/* Load a zone */
  void *answer;			/* Array of answer funcs */

  /* Optional functions */
  int (*zone_reload) (struct dnszonerec * zone);	/* Reload a zone */
  int (*zone_dump) ();		/* Dump a zone */
  int (*rr_add) ();		/* Add an RR */
  int (*rr_delete) ();		/* Delete an RR */
}
dnsmodulerec;

/* Prototypes */
dnsmodulerec *dns_module_open (guchar * modname);
void dns_module_close (dnsmodulerec * module);

#endif
