/* dns_module_syms.h - XXCOMMENTXX

   Dents - a threaded modular dns-server.
   Copyright (C) 1999  Dents Team  (http://www.dents.org)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or (at
   your option) any later version. This program is distributed in the
   hope that it will be useful, but WITHOUT ANY WARRANTY; without even
   the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
   PURPOSE.  See the GNU General Public License for more details.  */
/*
 * dns_module_syms.h
 *
 *  DNS specific macros for modules. See module_syms.h for further info
 */
#ifndef DNS_MODULE_SYMS_H
#define DNS_MODULE_SYMS_H

#include "module_syms.h"

#define MODULE_DNS_ANSWER		\
  void *_MOD_UNIQUE(dns_answer)[]

#if defined(STATIC_MODULE)

#define MODULE_SYMS_DNS			\
  { "module_dns_answer",		_MOD_UNIQUE(dns_answer) }, \
  { "module_dns_zone_add",		_MOD_UNIQUE(dns_zone_add) }, \
  { "module_dns_zone_delete",		_MOD_UNIQUE(dns_zone_delete) },

#define MODULE_SYMS_DNS_ZONE_LOAD	\
  { "module_dns_zone_load",		_MOD_UNIQUE(dns_zone_load) },

#define MODULE_SYMS_DNS_ZONE_RELOAD	\
  { "module_dns_zone_reload",		_MOD_UNIQUE(dns_zone_reload) },

#elif defined(DYNAMIC_MODULE)	/* STATIC_MODULE */

#define MODULE_SYMS_DNS
#define MODULE_SYMS_DNS_ZONE_LOAD
#define MODULE_SYMS_DNS_ZONE_RELOAD

#endif /* STATIC_MODULE | DYNAMIC_MODULE */

#endif
