/* interface.h - XXCOMMENTXX

   Dents - a threaded modular dns-server.
   Copyright (C) 1999  Dents Team  (http://www.dents.org)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or (at
   your option) any later version. This program is distributed in the
   hope that it will be useful, but WITHOUT ANY WARRANTY; without even
   the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
   PURPOSE.  See the GNU General Public License for more details.  */
/*
 * interface.h
 *
 *  Grabs a list of all interface's on the system, along with other generic
 * interface related routines
 */
#ifndef INTERFACE_H
#define INTERFACE_H

#include <netinet/in.h>

#include "link.h"

#define IF_MAXNAMELENGTH	255

typedef struct
{
  llentry ll;			/* Linked List */

  guchar name[IF_MAXNAMELENGTH + 1];	/* Interface name */
  struct in_addr address;	/* IP address of interface */
}
interfacerec;

extern linkedlist interfaces;

/*
 * Prototypes
 */
/* interface.c */
void interface_scan (void);

#endif
