/* redblack.h - XXCOMMENTXX

   Dents - a threaded modular dns-server.
   Copyright (C) 1999  Dents Team  (http://www.dents.org)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or (at
   your option) any later version. This program is distributed in the
   hope that it will be useful, but WITHOUT ANY WARRANTY; without even
   the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
   PURPOSE.  See the GNU General Public License for more details.  */
/*
 * RCS $Id: redblack.h,v 1.5 1999/07/30 20:58:51 illume Exp $
 */

/* Header file for redblack.c, should be included by any code that 
   ** uses redblack.c since it defines the functions 
 */

#ident  "@(#)redblack.h 1.4     95/06/12"

/* Modes for rblookup */
#define RB_NONE -1		/* None of those below */
#define RB_LUEQUAL 0		/* Only exact match */
#define RB_LUGTEQ 1		/* Exact match or greater */
#define RB_LULTEQ 2		/* Exact match or less */
#define RB_LULESS 3		/* Less than key (not equal to) */
#define RB_LUGREAT 4		/* Greater than key (not equal to) */
#define RB_LUNEXT 5		/* Next key after current */
#define RB_LUPREV 6		/* Prev key before current */
#define RB_LUFIRST 7		/* First key in index */
#define RB_LULAST 8		/* Last key in index */

/* Defines the VISIT structure */
#include <search.h>

struct rblists
{
  struct rbnode *rootp;
  struct rbnode *nextp;
};

#define RBLIST struct rblists

struct rbtree
{
  int (*rb_cmp) (void *, void *, void *);	/* comparison routine */
  void *rb_sdata;		/* data to be passed to compar */
  struct rbnode *rb_root;	/* root of tree */
};

#if !defined(__P)
#if defined(__STDC__)
#define __P(protos) protos
#else
#define __P(protos) ()
#endif
#endif

struct rbtree *rbinit __P ((int (*)(void *, void *, void *), void *));
void *rbdelete __P ((void *, struct rbtree *));
void *rbfind __P ((void *, struct rbtree *));
void *rblookup __P ((int, void *, struct rbtree *));
void *rbsearch __P ((void *, struct rbtree *));
void rbwalk
__P ((struct rbtree *, void (*)(void *, VISIT, int, void *), void *));
void rbwalkpre
__P ((struct rbtree *, void (*)(void *, VISIT, int, void *), void *));
void rbwalkpost
__P ((struct rbtree *, void (*)(void *, VISIT, int, void *), void *));
void rbwalkend
__P ((struct rbtree *, void (*)(void *, VISIT, int, void *), void *));
RBLIST *rbopenlist __P ((void *));
void *rbreadlist __P ((RBLIST *));
void rbcloselist __P ((RBLIST *));
void *rbmin __P ((struct rbtree *));
void *rbmax __P ((struct rbtree *));
void *rbdestroy __P ((struct rbtree *));
void *rbinsert __P ((void *, struct rbtree *));

/*

 * $Log: redblack.h,v $
 * Revision 1.5  1999/07/30 20:58:51  illume
 * Several changes made while trying to compile dents on an old solaris
 * host.
 *
 * Revision 1.4  1999/07/25 10:46:19  eric
 *
 * commented out debugging from event.c
 * Added a few new function calls to the redblack tree (just for walking the tree)
 * Also got rid of some compiler warnings.
 *
 * Revision 1.3  1999/07/21 02:54:14  grumple
 * Okay, I give.  These work and pass the tests.  Screw it.
 *
 * Revision 2.4  1999/02/10 03:28:43  damian
 * Maror re-do of redblack.c so that it uses the rbtree structure. Now we
 * can pass arbitrary data to the compare routine.
 *
 * Revision 2.3  1998/12/09 05:14:13  damian
 * Checks for existence of data directory and creates all the sub-directories
 *
 * Revision 2.2  1998/10/17 00:42:24  damian
 * Searches using the seqno now work properly. Also you can now read a deleted record
 * if you specify the seqno and do not specify an index.
 *
 * Revision 2.1  1997/01/22 03:24:50  damian
 * Jump to new new revision
 *
 * Revision 1.1  1996/06/21 19:04:31  root
 * Initial revision
 *
 */
