/* server-impl.c - XXCOMMENTXX

   Dents - a threaded modular dns-server.
   Copyright (C) 1999  Dents Team  (http://www.dents.org)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or (at
   your option) any later version. This program is distributed in the
   hope that it will be useful, but WITHOUT ANY WARRANTY; without even
   the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
   PURPOSE.  See the GNU General Public License for more details.  */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

/* Add system headers here */
#include <glib.h>

/* Add dents headers here */
#include "../include/common.h"

/* implementation routines for the dents control facility */

#include <stdio.h>		/* printf */
#include <string.h>		/* strlen, strncpy */
#include <time.h>		/* getuptime/time() */
#include <orb/orbit.h>		/* ORB mechanisms */
#include "ctlfac.h"		/* the glue for this whole mess */
#include "ctlfac-stats.h"	/* for struct ctlfac_stats */
#include "server-impl.h"	/* to keep us honest on our prototypes */

char implementation_name[] = "The Dents Name Server, v0.02";
extern time_t time_of_start, time_of_reset;
extern Dents_ctlfac_RecursionType server_recursion_type;
extern Dents_ctlfac_ResetState server_reset_state;
extern ctlfac_stats server_ctlfac_stats;

void
  getuptime
  (PortableServer_Servant servant,
   Dents_ctlfac_tul * uptime, CORBA_Environment * ev)
{

  uptime->timestamp = time (NULL);
  uptime->value = uptime->timestamp - time_of_start;
}

CORBA_char *
getident (Dents_ctlfac _obj, CORBA_Environment * ev)
{
  char *answer;
  size_t size;

  size = strlen (implementation_name);
  answer = CORBA_string_alloc (size);
  strncpy (answer, implementation_name, size);
  return (answer);
}

void
reset_server (PortableServer_Servant servant, CORBA_Environment * ev)
{
  /* FIXME: print information about ev here */
  time_of_reset = time (NULL);
  fprintf (stderr, "Server reset!\n");
}

void getresettime
  (PortableServer_Servant servant,
   Dents_ctlfac_tul * uptime, CORBA_Environment * ev)
{
  uptime->timestamp = time (NULL);
  uptime->value = uptime->timestamp - time_of_reset;
}

Dents_ctlfac_RecursionType
getrecursion (Dents_ctlfac _obj, CORBA_Environment * ev)
{
  return (server_recursion_type);
}

Dents_ctlfac_ResetState
getreset (PortableServer_Servant servant, CORBA_Environment * ev)
{
  return (server_reset_state);
}

void
  getauthans
  (PortableServer_Servant servant,
   Dents_ctlfac_tul * authans, CORBA_Environment * ev)
{
  authans->timestamp = time (NULL);
  authans->value = server_ctlfac_stats.authans;
}

void
  getauthnonames
  (PortableServer_Servant servant,
   Dents_ctlfac_tul * authnonames, CORBA_Environment * ev)
{
  authnonames->timestamp = time (NULL);
  authnonames->value = server_ctlfac_stats.authnonames;
}

void
  getauthnodata
  (PortableServer_Servant servant,
   Dents_ctlfac_tul * authnodata, CORBA_Environment * ev)
{
  authnodata->timestamp = time (NULL);
  authnodata->value = server_ctlfac_stats.authnodata;
}

void
  getauthdata
  (PortableServer_Servant servant,
   Dents_ctlfac_tul * authdata, CORBA_Environment * ev)
{
  authdata->timestamp = time (NULL);
  authdata->value = server_ctlfac_stats.authdata;
}

void
  getauthnodata
  (PortableServer_Servant servant,
   Dents_ctlfac_tul * authnodata, CORBA_Environment * ev)
{
  authnodata->timestamp = time (NULL);
  authnodata->value = server_ctlfac_stats.authnodata;
}

void
  getreferrals
  (PortableServer_Servant servant,
   Dents_ctlfac_tul * referrals, CORBA_Environment * ev)
{
  referrals->timestamp = time (NULL);
  referrals->value = server_ctlfac_stats.referrals;
}
