/* setup.h - XXCOMMENTXX

   Dents - a threaded modular dns-server.
   Copyright (C) 1999  Dents Team  (http://www.dents.org)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or (at
   your option) any later version. This program is distributed in the
   hope that it will be useful, but WITHOUT ANY WARRANTY; without even
   the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
   PURPOSE.  See the GNU General Public License for more details.  */
/*
 * setup.h
 *
 *  We'll keep commonly adjusted #define's in here so there's one easy place
 * to find them. These are just tweaks to the program which I don't think need
 * a config option or are too lazy to put in a config option :)
 */

/*
 * Number of receiver threads to prestart. This should really be moved out
 *  of here. This should be roughly 1 per number of CPU in the machine. Any
 *  more will see no performance increase (and may actually see a decrease)
 *
 * FIXME: Reset this value before releasing
 */
#ifdef DENTS_DEBUG
#define NUM_PRESTART_RECV 5
#else
#define NUM_PRESTART_RECV 1
#endif

/*
 * Default named.boot config file path (can be overridden with -c)
 */
#ifdef DENTS_DEBUG
#define NAMED_BOOT_COMPAT_PATH "named.boot"
#define DENTS_CONF_COMPAT_PATH "dents.conf"
#else
#define NAMED_BOOT_COMPAT_PATH "/etc/named.boot"
#define DENTS_CONF_COMPAT_PATH "/etc/dents.conf"
#endif

/*
 * Default dents.conf config file path
 */
#ifdef DENTS_DEBUG
#define DENTS_CONF_PATH "dents.conf"
#else
#define DENTS_CONF_PATH "/etc/dents.conf"
#endif

/*
 * Should we record from who and what time we received this information?
 *
 * FIXME: Use this
 */
#undef RECORD_FROM_WHO

/*
 * Value to pass to listen()
 */
#define MAX_LISTEN	32767
