/* sock_tcp.h - XXCOMMENTXX

   Dents - a threaded modular dns-server.
   Copyright (C) 1999  Dents Team  (http://www.dents.org)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or (at
   your option) any later version. This program is distributed in the
   hope that it will be useful, but WITHOUT ANY WARRANTY; without even
   the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
   PURPOSE.  See the GNU General Public License for more details.  */
/*
 * sock_tcp.h
 *
 *  TCP socket stuff
 */
#ifndef SOCK_TCP_H
#define SOCK_TCP_H

#define TCP_BUFFER_SIZE         4096

typedef struct
{
  struct in_addr ip;		/* IP Address of other side */
  guint16 port;			/* Port of other side */

  guint32 buffersize;		/* Size of the TCP buffer */
  guint16 bufferstart;		/* Where it starts in the first block */
  guint16 bufferend;		/* Where it ends in the last block */
  linkedlist buffer;		/* We buffer TCP streams */
}
tcppriv;

typedef struct
{
  llentry ll;			/* Linked List */

  guchar buffer[TCP_BUFFER_SIZE];
}
tcpbuffer;

extern linkedlist tcpsockets;

/* Prototypes */
int sock_tcp_sendbuf (struct socketrec *sock);
int sock_tcp_write (struct socketrec *sock, guchar * buf, int bufsize);
struct socketrec *sock_tcp_alloc (void);
void sock_tcp_free (struct socketrec *sock);

#endif
