/* al_parse_defs.h - XXCOMMENTXX

   Dents - a threaded modular dns-server.
   Copyright (C) 1999  Dents Team  (http://www.dents.org)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or (at
   your option) any later version. This program is distributed in the
   hope that it will be useful, but WITHOUT ANY WARRANTY; without even
   the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
   PURPOSE.  See the GNU General Public License for more details.  */

/*
 * arg_list_defs.h - pre-processor definitions to redefine yacc symbols
 * 
 * Author: Eric Z. Ayers
 *
 * A little bit of pre-processor trickery to get around problem of yacc
 * generating global symbols and wanting to include more than one parser
 * in our code.
 *
 * Basically, this just redfines all of the yyXXX labels to have a different
 * prefix.  This was taken from the automake documentation
 *
 */
#ifndef AL_PARSE_DEFS_H
#define AL_PARSE_DEFS_H

/******************************************************************************
 *			Pre Processor Definitions
 *****************************************************************************/

#define yyin       yy_al_in
#define yyout      yy_al_out
#define	yymaxdepth yy_al_maxdepth
#define	yyparse	yy_al_parse
#define	yylex	yy_al_lex
#define	yyerror	yy_al_error
#define	yylval	yy_al_lval
#define	yychar	yy_al_char
#define	yydebug	yy_al_debug
#define	yypact	yy_al_pact
#define	yyr1	yy_al_r1
#define	yyr2	yy_al_r2
#define	yydef	yy_al_def
#define	yychk	yy_al_chk
#define	yypgo	yy_al_pgo
#define	yyact	yy_al_act
#define	yyexca	yy_al_exca
#define yyerrflag yy_al_errflag
#define yynerrs	yy_al_nerrs
#define	yyps	yy_al_ps
#define	yypv	yy_al_pv
#define	yys	yy_al_s
#define	yy_yys	yy_al_yys
#define	yystate	yy_al_state
#define	yytmp	yy_al_tmp
#define	yyv	yy_al_v
#define	yy_yyv	yy_al_yyv
#define	yyval	yy_al_val
#define	yylloc	yy_al_lloc
#define yyreds	yy_al_reds
#define yytoks	yy_al_toks
#define yylhs	yy_al_yylhs
#define yylen	yy_al_yylen
#define yydefred yy_al_yydefred
#define yydgoto	yy_al_yydgoto
#define yysindex yy_al_yysindex
#define yyrindex yy_al_yyrindex
#define yygindex yy_al_yygindex
#define yytable	 yy_al_yytable
#define yycheck	 yy_al_yycheck
#define yyname   yy_al_yyname
#define yyrule   yy_al_yyrule

#define YYSTYPE	YY_AL_STYPE

/******************************************************************************
 *			Type Definitions
 *****************************************************************************/

/******************************************************************************
 *			Function Definitions
 *****************************************************************************/

/* from generated file arg_list_lexer.c */
void yy_al_scanner (char *string);
void yy_al_restart (FILE * input_file);

/* from generated file arg_list_parse.c */
int yy_al_parse (void);

/******************************************************************************
 *			Exported Data
 *****************************************************************************/
/* defined in arg_list_parse.l */
extern FILE *yy_al_in, *yy_al_out;

/* defined in arg_list_parse.y */
extern int yy_al_lineno;
extern int yy_al_debug;
extern ARG_HND global_al_parsed_hnd;
extern char *global_al_parsed_name;

#endif /* CONF_NC_DEFS_H */
